/********************************** (C) COPYRIGHT *******************************
* File Name          : pm_capacitor.h
* Author             : WCH
* Version            : V1.0
* Date               : 2023/06/06
* Description        :
********************************************************************************/

/*******************************************************************************/
#ifndef __PM_CAPACITOR_H
#define __PM_CAPACITOR_H

#ifdef __cplusplus
extern "C"
{
#endif

#include "ch32v30x.h"

/*********************************************************************************
 *                                  MACRO
 *********************************************************************************/
/* Voltage lower limit */
#define CAP_LOWER_LIMIT_VOLTAGE             ((u32)500)      //500mV

/* Voltage upper limit */
#define CAP_UPPER_LIMIT_ADC                 ((u16)3800)     //3060mV

/* Charge time upper limit */
#define CAP_UPPER_LIMIT_CHARGE_TIME         ((u32)13000)    //Լ1s


/*******************************************************************************
 *                                     FUNCTIONS
 *******************************************************************************/
u8 PM_CheckIsCapacitor(void);
u8 PM_MeasureCapacitor(void);


/********************************************************************************
********************************************************************************/

#ifdef __cplusplus
}
#endif

#endif
