/********************************** (C) COPYRIGHT *****************************
* File Name          : pm_adc.c
* Author             : WCH
* Version            : V1.0
* Date               : 2023/06/06
* Description        :
*******************************************************************************/

/******************************************************************************/
/* ͷļ */
#include "pm_adc.h"


/******************************************************************************
 *                             GLOBAL VARIABLES
 ******************************************************************************/
s16 Calibrattion_Val = 0;           //ADCУ׼ֵ
u16 ADC_Buf[ADC_BUF_MAX_LEN];       //ADCɼֵ


/*******************************************************************************
 * @fn      PM_ADCInit
 *
 * @brief   ADC1ʼGPIOͨʼΪģ룬DMA1ʼ
 *
 * @param   none
 *
 * @return  none
 *******************************************************************************/
void PM_ADCInit(void)
{
    ADC_InitTypeDef  ADC_InitStructure = {0};
    DMA_InitTypeDef DMA_InitStructure = {0};

    RCC_AHBPeriphClockCmd( RCC_AHBPeriph_DMA1, ENABLE );
    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA | RCC_APB2Periph_ADC1, ENABLE );
    RCC_ADCCLKConfig(RCC_PCLK2_Div8);                                       //ADCʱӲܳ14M,÷ƵΪ8,96M/8=12M

    ADC_DeInit(ADC1);                                                       //λADC1, ADC1ȫĴΪȱʡֵ
    ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;                      //ADC1ڶģʽ
    ADC_InitStructure.ADC_ScanConvMode = DISABLE;                           //رɨģʽ
    ADC_InitStructure.ADC_ContinuousConvMode = DISABLE;                     //رתģʽ
    ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;     //תⲿ
    ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;                  //ADCҶ
    ADC_InitStructure.ADC_NbrOfChannel = 1;                                 //תADCͨĿ
    ADC_Init(ADC1, &ADC_InitStructure);                                     //ADC1ʼ

    ADC_Cmd(ADC1, ENABLE);      //ʹADC1

    ADC_BufferCmd(ADC1, DISABLE);                           //ʹУ׼ǰҪرBuffer
    ADC_ResetCalibration(ADC1);                             //ʹܸλУ׼
    while(ADC_GetResetCalibrationStatus(ADC1));             //ȴλУ׼
    ADC_StartCalibration(ADC1);                             //ADУ׼
    while(ADC_GetCalibrationStatus(ADC1));                  //ȴУ׼
    Calibrattion_Val = Get_CalibrationValue(ADC1);          //ȡADC1У׼ֵ

    DMA_DeInit(DMA1_Channel1);                                                  //λDMA Channel1
    DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)&ADC1->RDATAR;              //ADCĹݼĴȡ
    DMA_InitStructure.DMA_MemoryBaseAddr = (u32)ADC_Buf;                        //ADCݽջ
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;                          //ԴADC
    DMA_InitStructure.DMA_BufferSize = ADC_BUF_MAX_LEN;                         //ĴСΪ32
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;            //ADCԴĵַҪ
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;                     //ĵַҪ
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord; //ݴСΪ
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;         //ݴСΪ
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;                               //DMA洢ģʽҪѭ
    DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh;                     //ͨȼΪ
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;                                //ǻ
    DMA_Init( DMA1_Channel1, &DMA_InitStructure );
}


/**********************************************************************
 * @fn      PM_ADCContinuousConvModeCmd
 *
 * @brief   Enables or disables the continuous convert mode of ADC.
 *
 * @param   ADCx - where x can be 1 or 2 to select the ADC peripheral.
 *          NewState - ENABLE or DISABLE.
 *
 * @return  none
 ***********************************************************************/
void PM_ADCContinuousConvModeCmd(ADC_TypeDef *ADCx, FunctionalState NewState)
{
    if(NewState != DISABLE)
    {
        ADCx->CTLR2 |= CTLR2_CONT_Set;
    }
    else
    {
        ADCx->CTLR2 &= CTLR2_CONT_Reset;
    }
}


/*********************************************************************
 * @fn      PM_ADCCalibrattion
 *
 * @brief   Get Conversion Value.
 *
 * @param   val - Sampling value
 *
 * @return  val+Calibrattion_Val - Conversion Value.
 *********************************************************************/
u16 PM_ADCCalibrattion(s16 val)
{
    if ((val + Calibrattion_Val) < 0)
    {
        return 0;
    }
    if (((val + Calibrattion_Val) > 4095) || (val == 4095))
    {
        return 4095;
    }
    return (val + Calibrattion_Val);
}


/*******************************************************************************
 * @fn      PM_GetADC
 *
 * @brief   ȡADC(βɼ)
 *
 * @param   ch - ͨѡ
 *          sample_time - ʱѡ
 *
 * @return  ADCֵ
 *******************************************************************************/
u16 PM_GetADC(u8 ch, u8 sample_time)
{
    u16 val;

    ADC_RegularChannelConfig(ADC1, ch, 1, sample_time);     //ָADCĹͨһ
    ADC_ClearFlag(ADC1, ADC_FLAG_EOC);                      //EOC־Էǰһתδȡ
    ADC_SoftwareStartConvCmd(ADC1, ENABLE);                 //ʹָADC1ת
    while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC));          //ȴת
    val = ADC_GetConversionValue(ADC1);                     //ADC1ת
    val = PM_ADCCalibrattion((s16)val);                     //ֵУ׼

    return val;
}


/*******************************************************************************
 * @fn      PM_GetADCAverage
 *
 * @brief   ȡADC(ȡƽֵ)
 *
 * @param   ch - ͨѡ
 *          times - ɼ
 *          sample_time - ʱѡ
 *
 * @return  (u16)ADCֵ
 *******************************************************************************/
u16 PM_GetADCAverage(u8 ch, u8 times, u8 sample_time)
{
    u32 val_sum = 0;
    u16 val = 0;
    u8 i;

    PM_GetADC(ch, ADC_SampleTime_239Cycles5);               //һתֵ
    Delay_Us(50);

    ADC_RegularChannelConfig(ADC1, ch, 1, sample_time);     //ָADCĹͨһ
    ADC_ClearFlag(ADC1, ADC_FLAG_EOC);                      //EOC־Էǰһתδȡ
    for(i=0; i<times; ++i)
    {
        ADC_SoftwareStartConvCmd(ADC1, ENABLE);             //ʹָADC1ת
        while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC));      //ȴת
        val_sum += ADC_GetConversionValue(ADC1);            //ADC1ת
        Delay_Us(50);
    }

    val = (val_sum * 10 / times + 5) / 10;                  //ƽֵ
    val = PM_ADCCalibrattion((s16)val);                     //ֵУ׼

    return val;
}


/*******************************************************************************
 * @fn      PM_DMA_GetADCAverage
 *
 * @brief   ȡADC(ȡƽֵ)ʹDMA
 *
 * @param   ch - ͨѡ
 *          times - ɼ
 *          sample_time - ʱѡ
 *
 * @return  (u16)ADCֵ
 *******************************************************************************/
u16 PM_DMA_GetADCAverage(u8 ch, u8 times, u8 sample_time)
{
    u32 val_sum = 0;
    u16 val = 0;
    u8 i;

    PM_GetADC(ch, ADC_SampleTime_239Cycles5);               //һתֵ
    Delay_Us(50);

    if(times > ADC_BUF_MAX_LEN) //ɼܳDMAĴС
    {
        times = ADC_BUF_MAX_LEN;
    }
    DMA_SetCurrDataCounter(DMA1_Channel1, times);           //DMAݵĸ,DMAʹܹܲ
    DMA_Cmd( DMA1_Channel1, ENABLE );                       //ʹDMA
    ADC_RegularChannelConfig(ADC1, ch, 1, sample_time );    //ָADCĹͨһ
    PM_ADCContinuousConvModeCmd(ADC1, ENABLE);              //ADCתģʽ
    ADC_DMACmd(ADC1, ENABLE);                               //ʹDMAģʽ
    ADC_SoftwareStartConvCmd(ADC1, ENABLE);                 //ADCת

    while(DMA_GetFlagStatus(DMA1_FLAG_TC1) == RESET);       //ȴDMA
    DMA_Cmd( DMA1_Channel1, DISABLE );                      //ʧDMA
    DMA_ClearFlag(DMA1_FLAG_TC1);                           //־
    PM_ADCContinuousConvModeCmd(ADC1, DISABLE);             //رADCתģʽ,ADCֹͣת
    ADC_DMACmd(ADC1, DISABLE);                              //رDMAģʽһDMAյһתɵ

    for(i=0; i<times; ++i)
    {
        val_sum += ADC_Buf[i];
    }
    val = (val_sum * 10 / times + 5) / 10;                  //ƽֵ
    val = PM_ADCCalibrattion((s16)val);                     //ֵУ׼

    return val;
}


/*******************************************************************************
 * @fn      PM_DMA_GetADCAverage_ForCAP
 *
 * @brief   ȡADCʹDMA
 *
 * @param   ch - ͨѡ
 *          sample_time - ʱѡ
 *          *p_count - ʱֵ
 *          *p_overflow - ʱֵ
 *
 * @return  (u16)ADCֵ
 *******************************************************************************/
u16 PM_DMA_GetADCAverage_ForCAP(u8 ch, u8 sample_time, u16 *p_count, u32 *p_overflow)
{
    u16 val = 0;

    PM_GetADC(ch, ADC_SampleTime_239Cycles5);               //һתֵ
    Delay_Us(50);

    DMA_SetCurrDataCounter(DMA1_Channel1, 1);               //DMAݵĸ,DMAʹܹܲ
    DMA_Cmd( DMA1_Channel1, ENABLE );                       //ʹDMA
    ADC_RegularChannelConfig(ADC1, ch, 1, sample_time );    //ָADCĹͨһ
    PM_ADCContinuousConvModeCmd(ADC1, ENABLE);              //ADCתģʽ
    ADC_DMACmd(ADC1, ENABLE);                               //ʹDMAģʽ
    ADC_SoftwareStartConvCmd(ADC1, ENABLE);                 //ADCת
    while(DMA_GetFlagStatus(DMA1_FLAG_TC1) == RESET);       //ȴDMA

    *p_overflow = TimerOverflowNum;
    *p_count = TIM_GetCounter(TIM2);
    if(*p_overflow != TimerOverflowNum)
    {
        *p_count = TIM_GetCounter(TIM2);
        *p_overflow = TimerOverflowNum;
    }

    DMA_Cmd( DMA1_Channel1, DISABLE );                      //ʧDMA
    DMA_ClearFlag(DMA1_FLAG_TC1);                           //־
    PM_ADCContinuousConvModeCmd(ADC1, DISABLE);             //رADCתģʽ,ADCֹͣת
    ADC_DMACmd(ADC1, DISABLE);                              //رDMAģʽһDMAյһתɵ

    val = PM_ADCCalibrattion((s16)ADC_Buf[0]);                     //ֵУ׼

    return val;
}


/*******************************************************************************
 * @fn      PM_ADCRealVol
 *
 * @brief   ADCʵʵѹֵ
 *
 * @param   val - ADCֵ
 *
 * @return  ʵʵѹֵ,λΪmV
 *******************************************************************************/
u32 PM_ADCRealVol(u16 val)
{
    return (((((u32) val * 8250) >> 10) + 5) / 10); // val / 4096 * 3300 + 0.5 
}


/******************************** endfile @ pm_adc ******************************/
